﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Apache.NMS.ActiveMQ;
using Apache.NMS;

namespace ConsoleProcucer
{
    class Program
    {
        static IConnectionFactory _factory = null;
        static IConnection _connection = null;
        static ITextMessage _message = null;

        static void Main(string[] args)
        {

            //创建工厂
            _factory = new ConnectionFactory("tcp://localhost:61616/");

            try
            {
                //创建连接
                using (_connection = _factory.CreateConnection())
                {
                    //创建会话
                    using (ISession session = _connection.CreateSession())
                    {
                        //创建一个主题，以主题方式发送/订阅消息
                        IDestination destination = new Apache.NMS.ActiveMQ.Commands.ActiveMQTopic("topic");

                        //创建生产者
                        IMessageProducer producer = session.CreateProducer(destination);

                        Console.WriteLine("Please click any key to continue... ");
                        Console.ReadKey();
                        Console.WriteLine("Sending: ");
                        Console.WriteLine("The message is 'Hello ActiveMQ...' ");

                        //创建一个文本消息
                        _message = producer.CreateTextMessage("Hello ActiveMQ....");

                        //发送消息
                        producer.Send(_message, MsgDeliveryMode.NonPersistent, MsgPriority.Normal, TimeSpan.MinValue);
                    }
                }

            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }

            Console.ReadLine();

        }
    }
}
