﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Apache.NMS;
using Apache.NMS.ActiveMQ;

namespace Producer
{
    public partial class ProducerFrm : Form
    {
        IConnectionFactory _factory = null;
        IConnection _connection = null;
        ITextMessage _message = null;

        public ProducerFrm()
        {
            InitializeComponent();
            btnSend.Click += new EventHandler(btnSend_Click);
        }

        protected override void OnShown(EventArgs e)
        {
            base.OnShown(e);
            try
            {
                //创建工厂
                _factory = new ConnectionFactory("tcp://localhost:61616/");

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        /// <summary>
        /// 点击【发送】触发
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void btnSend_Click(object sender, EventArgs e)
        {
            var textMsg = this.txtMessage.Text;
            //创建连接
            using (_connection = _factory.CreateConnection())
            {
                using (ISession session = _connection.CreateSession())
                {
                    //创建一个主题
                    IDestination destination = new Apache.NMS.ActiveMQ.Commands.ActiveMQTopic("topic");
                    
                    //创建生产者
                    IMessageProducer producer = session.CreateProducer(destination);

                    //创建一个文本消息
                    _message = producer.CreateTextMessage(textMsg);

                    //发送消息
                    producer.Send(_message, MsgDeliveryMode.NonPersistent, MsgPriority.Normal, TimeSpan.MinValue);
                }
            }
        }
    }
}
